{ import: Object-imp }
{ import: Object-lib }
{ import: Window-lib }

{ import: cairo-xlib }

App : Object ( win pix cs cr lastPoint track )

App init
[
    win := Surface new: (100@100 extent: 800@600).
    pix := win newPixmap: win extent.
    cs  := pix createCairoSurface.
    cr  := cs createContext.
    lastPoint := 180 @ 45.
    track := nil.
]

App run		[ [win waitEvent dispatchIn: self] repeat ]

Event			dispatchIn: app		[ ]
ExposeEvent		dispatchIn: app		[ app exposeEvent:	  self ]
MotionEvent		dispatchIn: app		[ app motionEvent:	  self ]
ButtonPressEvent	dispatchIn: app		[ app buttonPressEvent:   self ]
ButtonReleaseEvent	dispatchIn: app		[ app buttonReleaseEvent: self ]
KeyReleaseEvent		dispatchIn: app		[ app keyReleaseEvent:	  self ]

App exposeEvent: event	[ self draw ]

App draw
[
    cr
	identityMatrix;
	setSourceR: 1 G: 1 B: 1; rectangle: (0@0 extent: win extent); fill;
	setLineWidth: 0.01;
	setSourceR: 0.5 G: 0.5 B: 0.5;
	selectFontFace: 'Sans' slant: cr CAIRO_FONT_SLANT_NORMAL weight: cr CAIRO_FONT_WEIGHT_NORMAL;
	setFontSize:  7;  moveTo: 100@100; showText: 'Behind the ostensible government sits enthroned an invisible government owing no';
	setFontSize:  8;  moveTo: 100@120; showText: 'allegiance and acknowledging no responsibility to the people. To destroy this';
	setFontSize:  9;  moveTo: 100@140; showText: 'invisible government, to befoul the unholy alliance between corrupt business and';
	setFontSize: 10;  moveTo: 100@160; showText: 'corrupt politics is the first task of the statesmanship of today.';
	setFontSize: 11;  moveTo: 100@180; showText: '(President Theodore Roosevelt, 19 April 1906)';
	setSourceR: 1 G: 0 B: 0 A: 0.5; rectangle: (100@170 extent: 100@100); fill;
	setSourceR: 0 G: 1 B: 0 A: 0.5; rectangle: (130@200 extent: 100@100); fill;
	setSourceR: 0 G: 0 B: 1 A: 0.5; rectangle: (160@230 extent: 100@100); fill;
	setSourceR: 0.25 G: 0.25 B: 0.25 A: 0.95;
	setFontSize: 15;  moveTo: 20@320; showText: 'Behind the ostensible government sits enthroned an invisible government owing no';
	setFontSize: 16;  moveTo: 20@340; showText: 'allegiance and acknowledging no responsibility to the people. To destroy this';
	setFontSize: 17;  moveTo: 20@360; showText: 'invisible government, to befoul the unholy alliance between corrupt business and';
	setFontSize: 18;  moveTo: 20@380; showText: 'corrupt politics is the first task of the statesmanship of today.';
	setFontSize: 19;  moveTo: 20@400; showText: '(President Theodore Roosevelt, 19 April 1906)';
	setSourceR: 1 G: 0 B: 0 A: 0.5;
	arc:    50@285 radius: 15 from: 0 to: 2 * Float pi; fill;
	arc: lastPoint radius: 15 from: 0 to: 2 * Float pi; fill;
	setLineWidth: 12;
	setLineCap: cr CAIRO_LINE_CAP_ROUND;
	moveTo: 50@285; relLineTo: 300@0; relLineTo: 0@150; relLineTo: -170@0; lineTo: lastPoint; stroke;
	setFontSize: 15; moveTo: 50@500; showText: 'press ESCAPE to exit';
	setFontSize: 15; moveTo: lastPoint + (20@5); showText: '<-- drag me with the mouse'.
    pix drawOn: win at: 0@0.
]

App buttonPressEvent:   event	[ (lastPoint - event position) r < 15 ifTrue: [track := event position] ]
App buttonReleaseEvent: event	[ track := nil ]

App motionEvent: event
[
    track ifFalse: [^nil].
    lastPoint := lastPoint + event position - track.
    track := event position.
    self draw.
]

App keyReleaseEvent:   event	[ event keyCode == 27 ifTrue: [OS exit: 0] ]

[
    App new init run
]
