{ import: libcairo }

CairoContext : libcairo ( _context )

CairoContext withSurface_: _aSurface	[ ^self withContext_: (self _cairo_create : _aSurface) ]

CairoContext withContext_: _aContext
[
    self := self new.
    _context := _aContext.
]

CairoContext identityMatrix			[ self cairo_identity_matrix	: _context					 ]
CairoContext scale: aPoint			[ self cairo_scale		: _context : aPoint x : aPoint y		 ]
CairoContext setLineWidth: aNumber		[ self cairo_set_line_width	: _context : aNumber				 ]
CairoContext setLineCap: capStyle		[ self cairo_set_line_cap	: _context : capStyle				 ]
CairoContext setSourceR: r G: g B: b		[ self cairo_set_source_rgb	: _context : r : g : b				 ]
CairoContext setSourceR: r G: g B: b A: a	[ self cairo_set_source_rgba	: _context : r : g : b : a			 ]
CairoContext moveTo: aPoint			[ self cairo_move_to		: _context : aPoint x : aPoint y		 ]
CairoContext lineTo: aPoint			[ self cairo_line_to		: _context : aPoint x : aPoint y		 ]
CairoContext relLineTo: aPoint			[ self cairo_rel_line_to	: _context : aPoint x : aPoint y		 ]
CairoContext rectangle: r			[ self cairo_rectangle		: _context : r left : r top : r width : r height ]
CairoContext stroke				[ self cairo_stroke		: _context					 ]
CairoContext fill				[ self cairo_fill		: _context					 ]
CairoContext arc: pt radius: r from: a1 to: a2	[ self cairo_arc		: _context : pt x : pt y : r : a1 : a2		 ]
CairoContext save				[ self cairo_save		: _context					 ]
CairoContext restore				[ self cairo_restore		: _context					 ]

CairoContext selectFontFace: nameString slant: slantIndex weight: weightIndex
[
    self cairo_select_font_face : _context : nameString : slantIndex : weightIndex
]

CairoContext setFontSize: aNumber		[ self cairo_set_font_size	: _context : aNumber ]
CairoContext showText: aString			[ self cairo_show_text		: _context : aString ]

CairoContext deviceToUser: aPoint
[
    aPoint := aPoint x asFloat @ aPoint y asFloat.
    self cairo_device_to_user : aPoint x : aPoint y.	"destructive"
    ^aPoint
]

CairoSurface : Object ( _cairoSurface )

CairoSurface withCairoSurface_: _cs
[
    self := self new.
    _cairoSurface := _cs.
]

CairoSurface createContext	[ ^CairoContext withSurface_: _cairoSurface ]
