{ import: st80 }

Random : Object (seed a m q r)

Random initialize
[
	" Set a reasonable Park-Miller starting seed "
	seed := 1.
	a := 16807.0.
	m := 2147483647.0.
	q := m quo: a.
	r  := m \\ a.
]

Random seed: aNumber
[
	seed := aNumber
]

Random seed
[
	^ seed
]

Random nextValue
[
	"This method generates random instances of Integer 	in the interval
	0 to 16r7FFFFFFF. This method does NOT update the seed; repeated sends
	answer the same value.
	The algorithm is described in detail in 'Random Number Generators: 
	Good Ones Are Hard to Find' by Stephen K. Park and Keith W. Miller 
	(Comm. Asso. Comp. Mach., 31(10):1192--1201, 1988)."

	| lo hi aLoRHi answer |
	hi := (seed quo: q) asFloat.
	lo := seed - (hi * q).  " = seed rem: q"  
	aLoRHi := (a * lo) - (r * hi).
	answer := (aLoRHi > 0.0)
		ifTrue:  [aLoRHi]
		ifFalse: [aLoRHi + m].
	^ answer
]

Random next
[
	"Answer a random Float in the interval [0 to 1)."
	^ (seed := self nextValue) / m
]

Random theItsCompletelyBrokenTest
[
	"Random theItsCompletelyBrokenTest"
	"The above should print as...
	(0.149243269650845 0.331633021743797 0.75619644800024 0.393701540023881 0.941783181364547 0.549929193942775 0.659962596213428 0.991354559078512 0.696074432551896 0.922987899707159 )
	If they are not these values (accounting for precision of printing) then something is horribly wrong: DO NOT USE THIS CODE FOR ANYTHING. "

	| rng |
	rng := Random new.
	rng seed: 2345678901.0.
	^ 1 to: 10 do: [:i | rng next println]
]
